



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>&lt;Win32_1&gt;深入浅出windows消息机制[转自crocodile_]</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">&lt;Win32_1&gt;深入浅出windows消息机制[转自crocodile_]</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 00:57:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>上学期学习了Java ，感觉Java写一个窗口真心简单，很易上手，也就难怪很多开发人员选择Java作为自己的开发编程语言。但是由于自身对windows的热爱，让我觉得c、c++语言才是我亲睐的编程语言，虽然难度大些，但是这才能体现能力所在。其实之前一直想自学一下win32，但是由于时间的显示和种种原因而耽搁了，于是今年暑假决心深入学习win32。</p>
<p>在学习过程中呢，我会在此留下自己的学习心得，当做自己的笔记。初学者可以借鉴，高手可以多多指教，呵呵&hellip;&hellip;</p>
<p>好了，今天开始做第一课的笔记吧：</p>
<p>学习Win32最好是对windows操作系统有较为深入的理解，这样才能学得深入、扎实。因此学习Win32的第一步就是了解windows</p>
<p>操作系统的消息机制，这个可是重中之重</p>
<p>首先上一张自己亲手绘制的图，能很清晰地表示windows消息机制的工作原理</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130723093110015" /></p>
<p>也许你初次看到这张图，感觉密密麻麻的，不是很懂，别担心，我将逐步讲解：</p>
<p>(1)&nbsp;&nbsp; 数字1箭头:&nbsp; 表示windows(os)将消息传递到应用程序的消息队列中</p>
<p>(2)&nbsp;&nbsp; 数字2箭头:&nbsp; 表示应用程序通过消息循环在消息队列中读取消息</p>
<p>(3)&nbsp;&nbsp; 数字3箭头:&nbsp; 表示应用程序的消息循环将读取到的消息告诉给windows(os)</p>
<p>(4)&nbsp;&nbsp; 数字4箭头:&nbsp; 表示windows(os)通过应用程序传递的消息来调用应用程序绑定的回调函数(WndProc) , 根据回调函数 , 来确定是否做出响应</p>
<p>到这里，想必你能从本质上了解到windows的消息机制了吧</p>
<p>讲程序终究和代码脱不了关系，下面我借用一下P先生(Charles Petzold)的第一个例子(HelloWin.c)，不过里面包含了我自己的东西，你一看就知道了：</p>
<div>
<div>
<div><strong>[cpp]</strong>&nbsp;<a href="http://blog.csdn.net/crocodile__/article/details/9417439" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/crocodile__/article/details/9417439" rel="external nofollow noreferrer">copy</a><a href="http://blog.csdn.net/crocodile__/article/details/9417439" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/crocodile__/article/details/9417439" rel="external nofollow noreferrer">?</a></p>
<div></div>
</div>
</div>
<ol><li>//windows程序的基础代码</li>
<li>#include&lt;windows.h&gt;</li>
<li>LRESULT&nbsp;CALLBACK&nbsp;WndProc(HWND,&nbsp;UINT,&nbsp;WPARAM,&nbsp;LPARAM);//回调函数声明</li>
<li>int&nbsp;WINAPI&nbsp;WinMain(HINSTANCE&nbsp;hInstance,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;程序的当前实例句柄</li>
<li>HINSTANCE&nbsp;hPrevInstance,&nbsp;//&nbsp;程序的上一个实例句柄&nbsp;,&nbsp;在win32程序中&nbsp;,&nbsp;它始终是NULL</li>
<li>PSTR&nbsp;szCmdLine,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;命令行</li>
<li>int&nbsp;iCmdShow)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;窗口显示状态</li>
<li>{</li>
<li>static&nbsp;&nbsp;TCHAR&nbsp;&nbsp;&nbsp;szAppName[]&nbsp;=&nbsp;TEXT("HelloWin");&nbsp;//以'\0'字符结尾的字符串&nbsp;,&nbsp;这里是程序的名称(实际用作后面的窗口类的名字)</li>
<li>HWND&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hwnd;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口句柄</li>
<li>MSG&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;msg;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//消息结构体</li>
<li>WNDCLASS&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;wndclass;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口类</li>
<li>wndclass.style&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;CS_HREDRAW&nbsp;|&nbsp;CS_VREDRAW;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口类的风格</li>
<li>wndclass.lpfnWndProc&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;WndProc;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口类绑定的回调函数(也称为窗口过程)</li>
<li>wndclass.cbClsExtra&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;0;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口类额外参数(默认为0)</li>
<li>wndclass.cbWndExtra&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;0;//窗口类额外参数(默认为0)</li>
<li>wndclass.hInstance&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;hInstance;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//程序的当前实例句柄&nbsp;,&nbsp;绑定到窗口类中</li>
<li>wndclass.hIcon&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;LoadIcon(NULL,&nbsp;IDI_APPLICATION);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//加载程序图标</li>
<li>wndclass.hCursor&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=&nbsp;LoadCursor(NULL,&nbsp;IDC_ARROW);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//加载光标</li>
<li>wndclass.hbrBackground&nbsp;&nbsp;=&nbsp;(HBRUSH)GetStockObject(WHITE_BRUSH);&nbsp;&nbsp;//背景刷</li>
<li>wndclass.lpszMenuName&nbsp;&nbsp;&nbsp;=&nbsp;NULL;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//菜单名指针</li>
<li>wndclass.lpszClassName&nbsp;&nbsp;=&nbsp;szAppName;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口类的名字</li>
<li>if(!RegisterClass(&amp;wndclass))//注册窗口类</li>
<li>{</li>
<li>MessageBox(NULL,&nbsp;TEXT("This&nbsp;program&nbsp;requires&nbsp;Windows&nbsp;NT!"),</li>
<li>szAppName,&nbsp;MB_ICONERROR);</li>
<li>return&nbsp;0;</li>
<li>}</li>
<li>//这里创建的是一段内存&nbsp;,&nbsp;用于存储创建窗口的信息&nbsp;,&nbsp;同时返回该窗口的一个句柄(窗口的标示)</li>
<li>hwnd&nbsp;=&nbsp;CreateWindow(szAppName,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口类的名字</li>
<li>TEXT("The&nbsp;Hello&nbsp;Program"),&nbsp;&nbsp;//窗口名称(标题栏显示的内容)</li>
<li>WS_OVERLAPPEDWINDOW,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口的风格</li>
<li>CW_USEDEFAULT,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口x坐标</li>
<li>CW_USEDEFAULT,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口y坐标</li>
<li>CW_USEDEFAULT,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口宽度</li>
<li>CW_USEDEFAULT,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口长度</li>
<li>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//父窗口句柄</li>
<li>NULL,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//菜单句柄</li>
<li>hInstance,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//程序的当前实例</li>
<li>NULL);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//窗口创建数据</li>
<li>/*&nbsp;程序运行完CreateWindow&nbsp;,&nbsp;还没运行ShowWindow时&nbsp;,</li>
<li>windows向窗口的WndProc发送了第一条消息:&nbsp;WM_Create&nbsp;*/</li>
<li>ShowWindow(hwnd,&nbsp;iCmdShow);&nbsp;//显示窗口</li>
<li>UpdateWindow(hwnd);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//更新窗口</li>
<li>/*&nbsp;运行完UpdateWindow后&nbsp;,&nbsp;windows向窗口的WndProc</li>
<li>发送了第二条消息:&nbsp;WM_PAINT&nbsp;.&nbsp;如果ShowWindow没有调用或是调用失败&nbsp;,&nbsp;WM_PAINT消息是不会发送的*/</li>
<li>//消息循环</li>
<li>while(GetMessage(&amp;msg,&nbsp;NULL,&nbsp;0,&nbsp;0))//这里的NULL不能写成hwnd&nbsp;,&nbsp;否则程序不能正常运行</li>
<li>{</li>
<li>TranslateMessage(&amp;msg);//转换键盘消息</li>
<li>DispatchMessage(&amp;msg);//将消息传送给windows(os)&nbsp;,&nbsp;由windows来回调</li>
<li>}</li>
<li>return&nbsp;msg.wParam;//结束返回</li>
<li>}</li>
<li>//窗口过程(回调函数)</li>
<li>LRESULT&nbsp;CALLBACK&nbsp;WndProc(HWND&nbsp;hwnd,&nbsp;UINT&nbsp;message,&nbsp;WPARAM&nbsp;wParam,&nbsp;LPARAM&nbsp;lParam)</li>
<li>{</li>
<li>HDC&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hdc;&nbsp;&nbsp;&nbsp;&nbsp;//设备句柄</li>
<li>PAINTSTRUCT&nbsp;ps;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//包含窗口客户区绘制的信息&nbsp;&nbsp;是一个结构体</li>
<li>RECT&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rect;&nbsp;&nbsp;&nbsp;//矩形(两个点)</li>
<li>//这里是消息处理</li>
<li>switch(message)</li>
<li>{</li>
<li>//窗口创建消息</li>
<li>case&nbsp;WM_CREATE:</li>
<li>//PlaySound&nbsp;(TEXT&nbsp;("hellowin.wav"),&nbsp;NULL,&nbsp;SND_FILENAME&nbsp;|&nbsp;SND_ASYNC)&nbsp;;//播音</li>
<li>return&nbsp;0&nbsp;;</li>
<li>//窗口客户区重绘消息</li>
<li>case&nbsp;WM_PAINT:</li>
<li>PlaySound&nbsp;(TEXT&nbsp;("hellowin.wav"),&nbsp;NULL,&nbsp;SND_FILENAME&nbsp;|&nbsp;SND_ASYNC)&nbsp;;//播音</li>
<li>hdc&nbsp;=&nbsp;BeginPaint(hwnd,&nbsp;&amp;ps);//获取设备句柄&nbsp;,&nbsp;开始重绘</li>
<li>GetClientRect(hwnd,&nbsp;&amp;rect);//获取客户区的大小</li>
<li>DrawText(hdc,&nbsp;TEXT("Hello,&nbsp;Windows&nbsp;98!"),&nbsp;-1,&nbsp;&amp;rect,</li>
<li>DT_SINGLELINE&nbsp;|&nbsp;DT_CENTER&nbsp;|&nbsp;DT_VCENTER);//绘制一个字符串</li>
<li>EndPaint(hwnd,&nbsp;&amp;ps);//结束重绘</li>
<li>return&nbsp;0;</li>
<li>//窗口退出消息</li>
<li>case&nbsp;WM_DESTROY:</li>
<li>PostQuitMessage(0);//发送退出消息</li>
<li>return&nbsp;0;</li>
<li>}</li>
<li>return&nbsp;DefWindowProc(hwnd,&nbsp;message,&nbsp;wParam,&nbsp;lParam);</li>
<li>//windows对于消息的默认处理</li>
<li>//(注意:&nbsp;第三个和第四个参数不能传递错误!!!)</li>
<li>}</li></ol>
</div>
<p>没错，我逐行注释了，这样我觉得很好，对于掌握和理解是很有帮助的，ni不放试试&hellip;&hellip;</p>
<p>好了，今天到此为止吧，下次继续了^_^</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdw6zz9.html">Cats（4）－ 叠加Free程序运算结果，Stacking monadic result types</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g4nw49.html">jquery&period;validate使用 - 常用验证脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq43oz58.html">IO碰到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93r04r9.html">Ajax注册验证js代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z136xn9.html">COS回应7大质疑</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj7rxy9.html">PHP数组的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mjp7xq.html">Windows获取其他进程中Edit控件的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1mvoq.html">poj 1106 Transmitters &lpar;枚举&plus;叉积运用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdyr0y8.html">js冲突怎么解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd364z8.html">iOS textfield限制长度，中文占2字符，英文占1字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vovmj8.html">poj 1328 Radar Installation&lowbar;贪心</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kz7vz9.html">&lbrack;ACM&rsqb; poj 1258 Agri-Net &lpar;最小生成树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p0n038.html">栈和队列简单的STL模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey4g3m9.html">socket网络编程快速上手（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxlv09.html">NIO相关基础篇二</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z57l09.html">python 面向对象之继承与派生</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5dv4eq.html">js中Array的map&lpar;&rpar;函数，其中的回调函数还能这么用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jp0n3q.html">i春秋-百度杯十月场-fuzzing</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv5r5g8.html">做项目单个功能的时候要理解需求和sql语句。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvnrzz8.html">nmon监控与 nmon analyser分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1oek39.html">Linux 进程（一）：环境及其控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn233j8.html">c&sol;c&plus;&plus;常用代码--string trim</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0m54wq.html">self&period;a 和 &lowbar;a 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdl6pk8.html">JS-数值篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m7xpgq.html">【转载】spring的普通类中如何取session和request对像</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y4ynnq.html">C&num; Redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1v13d9.html">bzoj 3142 数学</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wxwvvq.html">hdu 3007 Buried memory 最远点对</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wxjwwq.html">Matlab稀疏矩阵</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1mj0j9.html">自定义对话框 提示：Unable to add window token null is not for an application</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
